# Purpose

The purpose of this change was to fix and simplify Slider's API. It removes the `range` prop so non-uniform step distribution is no longer supported. However, it introduces `min` and `max` props so you can still set the upper and lower boundaries.

## Slider

Basic use-case of `range` prop can be replaced by `min` and `max`

```diff
- <Slider range={[0, 100]} />
+ <Slider min={0} max={100} />
```

## onChange

`onChange` now gets only one parameter `value`. Previously, it also got the underlying `event`. That is now removed, mostly because it's an implementation detail and should not be exposed. It decreases the API surface and lets us iterate without breaking changes.

```diff
- <Slider onChange={({value, event}) => {}} />
+ <Slider onChange={({value}) => {}} />
```
