# Purpose

The `StyledContent` component caused issues when only a few rows were rendered in the table. The Table
component was refactored in a way that no longer uses the `StyledContent` component. Your code may have previously
depended on this component, but should be changed to the pattern outlined below.

## Table

```diff
<StyledTable>
  <StyledHead>
    {columns.map((column, index) => (
      <StyledHeadCell key={index}>
        {column}
      </StyledHeadCell>
    ))}
  </StyledHead>

- <StyledContent>
  <StyledBody>
    {filteredData.map((row, index) => (
      <StyledRow key={index}>
        {row.map((cell, cellIndex) => (
          <StyledCell key={cellIndex}>{cell}</StyledCell>
        ))}
      </StyledRow>
    ))}
   </StyledBody>
-  </StyledContent>
</StyledTable>
```
