/*
Copyright (c) 2018-2019 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
// @flow
// BASEUI-GENERATED-REACT-ICON
// DO NOT EDIT THIS FILE DIRECTLY, SEE README.md
import * as React from 'react';
import Icon from './icon.js';
import type {IconPropsT} from './types.js';
import {ThemeContext} from '../styles/theme-provider.js';

export default function Plus(props: IconPropsT) {
  return (
    <ThemeContext.Consumer>
      {theme =>
        theme.icons && theme.icons.Plus ? (
          <theme.icons.Plus title="Plus" viewBox="0 0 24 24" {...props} />
        ) : (
          <Icon title="Plus" viewBox="0 0 24 24" {...props}>
            <path
              fillRule="evenodd"
              clipRule="evenodd"
              d="M12 5C12.5523 5 13 5.44772 13 6V11L18 11C18.5523 11 19 11.4477 19 12C19 12.5523 18.5523 13 18 13L13 13V18C13 18.5523 12.5523 19 12 19C11.4477 19 11 18.5523 11 18V13L6 13C5.44772 13 5 12.5523 5 12C5 11.4477 5.44771 11 6 11L11 11V6C11 5.44772 11.4477 5 12 5Z"
            />
          </Icon>
        )
      }
    </ThemeContext.Consumer>
  );
}
